#ifndef __AUDIO_H
#define __AUDIO_H


#include "types.h"

typedef struct SOUNDREG
{
	u8 ctl;
	u8 spacer1[3];
	u8 vol;
	u8 spacer2[3];
	u8 fql;
	u8 spacer3[3];
	u8 fqh;
	u8 spacer4[3];
	u8 env;
	u8 spacer5[3];
	u8 unk;
	u8 spacer6[3];
	u8 ram;
	u8 spacer7[3];
	u8 spacer8[36];
} SOUNDREG;

u8* const SND1DATA =		(u8*)0x01000000;
u8* const SND2DATA =		(u8*)0x01000080;
u8* const SND3DATA =		(u8*)0x01000100;
u8* const SND4DATA =		(u8*)0x01000180;
u8* const SWEEPDATA =		(u8*)0x01000200;
u8* const MODDATA =		(u8*)0x01000280;
SOUNDREG* const SND_REGS =	(SOUNDREG*)0x01000400; //(SOUNDREG*)0x010003C0;
u8* const SMREG =		(u8*)0x01000580;

/***** Sound Register Mnemonics *****/
#define	WAVE1	0x00	// Voluntary wave channel #1
#define	WAVE2	0x01	// Voluntary wave channel #2
#define	WAVE3	0x02	// Voluntary wave channel #3
#define	WAVE4	0x03	// Voluntary wave channel #4
#define	SWEEP	0x04	// Sweep/modulation channel
#define	NOISE	0x05	// Pseudorandom noise channel


#endif
